import SpriteKit

public class CursorController {
    
    var cursor = SKSpriteNode()
    
    var cursorVector = CGVector()
    var mousePosition = CGPoint()
    
    public func updateMovement() {
        cursorVector.dx = mousePosition.x - cursor.position.x
        cursorVector.dy = mousePosition.y - cursor.position.y
        cursor.physicsBody?.velocity.dx += cursorVector.dx
        cursor.physicsBody?.velocity.dy += cursorVector.dy
    }
    
    public func setCursor() {
        cursor.physicsBody = SKPhysicsBody(rectangleOf: CGSize(width: 1, height: 1))
        cursor.physicsBody?.affectedByGravity = false
        cursor.physicsBody?.allowsRotation = false
        cursor.physicsBody?.linearDamping = 5
        cursor.physicsBody!.contactTestBitMask = 1 | 2 | 3
    }
}
