import SpriteKit

public class Game1: SKScene, SKPhysicsContactDelegate {
    
    var cursorController = CursorController()
    
    var startPos = CGPoint()
    
    public override func didMove(to view: SKView) {
        super.didMove(to: view)
        self.physicsWorld.contactDelegate = self
        cursorController.cursor = self.childNode(withName: "cursor") as! SKSpriteNode
        let nodes = self.children
        for i in 0..<nodes.count {
            if (nodes[i].name == "wall") {
                let shapenode = nodes[i] as! SKShapeNode
                shapenode.physicsBody = SKPhysicsBody(rectangleOf: CGSize(width: shapenode.xScale * 100, height: shapenode.yScale * 100))
                shapenode.physicsBody?.affectedByGravity = false
                shapenode.physicsBody?.isDynamic = false
                shapenode.physicsBody!.contactTestBitMask = 1
            }
            if (nodes[i].name == "kill") {
                let shapenode = nodes[i] as! SKShapeNode
                shapenode.physicsBody = SKPhysicsBody(rectangleOf: CGSize(width: shapenode.xScale * 100, height: shapenode.yScale * 100))
                shapenode.physicsBody?.affectedByGravity = false
                shapenode.physicsBody?.isDynamic = false
                shapenode.physicsBody!.contactTestBitMask = 2
            }
            if (nodes[i].name == "end") {
                let shapenode = nodes[i] as! SKShapeNode
                shapenode.physicsBody = SKPhysicsBody(rectangleOf: CGSize(width: shapenode.xScale * 100, height: shapenode.yScale * 100))
                shapenode.physicsBody?.affectedByGravity = false
                shapenode.physicsBody?.isDynamic = false
                shapenode.physicsBody!.contactTestBitMask = 3
            }
        }
        startPos = self.childNode(withName: "start")!.position
        cursorController.cursor.position = startPos
        cursorController.setCursor()
        let mouseTrack = NSTrackingArea(rect: view.frame, options: [.mouseMoved, .activeInKeyWindow], owner: self, userInfo: nil)
        self.view?.addTrackingArea(mouseTrack)
    }
    
    
    
    public override func mouseMoved(with event: NSEvent) {
        super.mouseMoved(with: event)
        let location = event.location(in: self)
        cursorController.mousePosition = location
    }
    
    public override func update(_ currentTime: TimeInterval) {
        cursorController.updateMovement()
    }
    
    public func didBegin(_ contact: SKPhysicsContact) {
        if (contact.bodyA.node?.name! == "kill") {
            cursorController.cursor.physicsBody = nil
            cursorController.cursor.position = startPos
            cursorController.setCursor()
        }
        if (contact.bodyA.node?.name! == "end") {
            let transition = SKTransition.fade(withDuration: 0.5)
            guard let selectionScene = SelectionScene(fileNamed: "SelectionScene") else {
                fatalError("Unable to load selectionScene")
            }
            selectionScene.level = 2
            self.scene?.view?.presentScene(selectionScene, transition: transition)
        }
    }
}
